<template>
  <div
    v-if="!isVisibilityMode || (isVisibilityMode && !finished)"
    class="ob-countdown"
  >
    <template v-if="!isVisibilityMode">
      <i
        v-if="isIcon || isOnlyIcon"
        :class="[
          'icon',
          strIcon,
          isDanger && isOnlyIcon && '-light-raspberry-red'
        ]"
      />

      <template v-if="!isOnlyIcon">
        <slot
          v-if="finished && $slots.finished"
          name="finished"
        />

        <span
          v-else
          :class="isDanger && '-light-raspberry-red'"
        >
          {{ display }}
        </span>
      </template>
    </template>

    <slot />
  </div>
</template>

<script>
import moment from 'moment'

export default {
  name: 'ObCountdown',

  props: {
    duration: {
      type: [String, Number],
      default: 0
    },
    fromDate: {
      type: [String, Date],
      default: null
    },
    toDate: {
      type: [String, Date],
      default: null
    },
    finishedText: {
      type: String,
      default: '-'
    },
    isIcon: {
      type: Boolean,
      default: false
    },
    strIcon: {
      type: String,
      default: 'clock'
    },
    isOnlyIcon: {
      type: Boolean,
      default: false
    },
    funcIsDanger: {
      type: Function,
      default: null
    },
    isVisibilityMode: {
      type: Boolean,
      default: false
    }
  },

  data () {
    return {
      start: this.generateDate(this.fromDate).valueOf(),
      end: this.generateDate(this.toDate).add({ seconds: this.duration || 0 }).valueOf(),
      tick: null
    }
  },
  computed: {
    remaining () {
      return this.finished ? null : this.end - this.start
    },
    display () {
      if (this.finished) {
        return this.finishedText
      }

      let duration = moment.duration(this.remaining)
      let years = duration.years()
      let months = duration.months()
      let days = duration.days()
      let hours = duration.hours()
      let minutes = duration.minutes()
      let seconds = duration.seconds()
      let result = ''
      if (years >= 1) {
        result = years + ' г'
      } else if (months >= 1) {
        result = months + ' мес'
      } else if (days >= 3) {
        result = days + ' д'
      } else if (days >= 1) {
        result = days + ' д ' + hours + ' ч'
      } else if (hours >= 1) {
        result = hours + ' ч ' + minutes + ' мин'
      } else if (minutes >= 1) {
        result = minutes + ' мин'
      } else {
        result = seconds + ' с'
      }

      return result
    },
    finished () {
      return !this.fromDate && this.start >= this.end
    },
    isDanger () {
      return (this.funcIsDanger ? this.funcIsDanger(this.getRemainingObj()) : this.remaining < 60000) && !this.fromDate && !this.finished
    }
  },
  watch: {
    finished (val) {
      if (val) {
        this.$emit('finished')
      }
    },
    start () {
      if (this.finished) {
        clearInterval(this.tick)
      }
    },
    duration () {
      this.end = this.generateDate().add({ seconds: this.duration || 0 }).valueOf()
      this.startTimer()
    },
    fromDate () {
      this.start = this.generateDate(this.fromDate).valueOf()
      this.startTimer()
    },
    toDate () {
      this.end = this.generateDate(this.toDate).add({ seconds: this.duration || 0 }).valueOf()
      this.startTimer()
    }
  },
  mounted () {
    this.startTimer()
  },
  beforeDestroy () {
    clearInterval(this.tick)
  },
  methods: {
    generateDate (date) {
      if (!moment(date).isValid()) {
        return moment()
      } else {
        return moment(date)
      }
    },
    getRemainingObj () {
      return {
        seconds: Math.floor(this.remaining / 1000),
        minutes: Math.floor(this.remaining / (1000 * 60)),
        hours: Math.floor(this.remaining / (1000 * 60 * 60)),
        days: Math.floor(this.remaining / (1000 * 60 * 60 * 24)),
        now: this[this.fromDate && !this.toDate ? 'end' : 'start']
      }
    },
    startTimer () {
      clearInterval(this.tick)
      if (!(this.fromDate && this.toDate)) {
        this.tick = setInterval(() => {
          this[this.fromDate && !this.toDate ? 'end' : 'start'] = moment().valueOf()
        }, 1000)
      }
    }
  }
}
</script>

<style lang="scss" scoped>
.ob-countdown {
  display: inline-flex;
  align-items: center;
  .icon {
    margin-right: 5px;
    font-size: 22px;
    color: $color-blue-navy-blue;
  }
}
</style>
